<Query Kind="Program">
  <Namespace>System.Collections.Concurrent</Namespace>
</Query>

void Main() {
  // 使用 List<T> 的初始化
  // 設定初始大小=5
  List < int > numbers = new List < int >(5) {
    1,
    2,
    3,
    4,
    5
  };

  // 使用 Dictionary<TKey, TValue> 的初始化
  Dictionary < string, int > ages = new Dictionary < string, int > {
    {
      "Rico",
      30
    },
    {
      "Fifi",
      25
    }
  };

  // 使用 HashSet<T> 保證唯一性
  HashSet < string > uniqueNames = new HashSet < string > {
    "Rico",
    "Bob",
    "Charlie",
    "Rico"
  };
  Console.WriteLine("Unique Names: " + string.Join(", ", uniqueNames));//Rico Bob Charlie

  // 使用 ConcurrentDictionary 進行並行操作
  var concurrentDictionary = new ConcurrentDictionary < string, int > ();
  concurrentDictionary.TryAdd("key1", 1);
  concurrentDictionary.TryAdd("key2", 2);
  Console.WriteLine("ConcurrentDictionary: " + string.Join(", ", concurrentDictionary.Select(kvp => kvp.Key + "=" + kvp.Value)));
 
  // 避免不必要的複製
  var filteredList = numbers.Where(n => n > 2).ToList();
  
  // 直接使用延遲執行的結果
  var filteredNumbers = numbers.Where(n => n > 2);
  Console.WriteLine("Filtered Numbers: " + string.Join(", ", filteredNumbers));

  // 清理集合
  numbers.Clear();
  Console.WriteLine("Numbers after clear: " + numbers.Count);//0

}